#!/usr/bin/env python
import GUIbackend
from wxPython.wx import *
import time
import Preferences
import pickle
import os
import sys
from widgets import utils
import widgets.UserInfoFrame
import widgets.MessageFrame
import widgets.EventFrame
import widgets.GUITree
import widgets.PreferencesFrame
import widgets.AuthFrame
import widgets.AddUserFrame
eventsQueueHash = {}
imcom = None
theListJidDict = {}

IM_RECEIVEEVENT = 10
IM_SENDMESSAGE = 11
IM_GETINFO = 12
IM_REMOVEUSER = 13
IM_ADDUSER = 14
IM_SETNICK = 15

# TODO:
#
# Group support
# File Xfer
# handle errors gracefully
# agent registration
# set default profile
# account creation
# handle $HOME not being there...
# animated status thingies...
# live in systray, handle dclick in systray
# bind c-s-z to dclick systray if possible..
# focus after sending a message..
# history...
# graphical handlers for each of the other Events..

class SimpleTextFrame(wxFrame): #this isn't used...
    def __init__(self, parent, ID, title, text):
        wxFrame.__init__(self, parent, ID, title,
                         wxDefaultPosition, wxSize(350,350))
        panel = wxPanel(self, -1)
        box = wxBoxSizer(wxVERTICAL)
        bbox = wxBoxSizer(wxHORIZONTAL)
        textID = NewId()
        self.textctrl = wxTextCtrl(panel, textID, "")
        box.Add(wxStaticText(panel, -1, text), 0, wxEXPAND | wxALL, 10)
        box.Add(self.textctrl, 1, wxEXPAND | wxALL, 10)
        bbox.Add(wxButton(panel, wxID_OK, " Ok "), 0, wxALL, 10)
        bbox.Add(wxButton(panel, wxID_CANCEL, " Cancel "), 0, wxALL, 10)
        box.Add(bbox, 0, wxEXPAND)
        panel.SetAutoLayout(true)
        panel.SetSizer(box)
        box.Fit(panel)


def findItemInDict(dict, item): # this isn't used...
    keys = dict.keys()
    for blah in keys:
        if(dict[blah] == item):
            return blah
    return None



class GUI(wxPanel):
    def __init__(self, parent, name, mainframe):
        global imcom, eventsQueueHash
        self.parent = parent
        wxPanel.__init__(self, parent, -1, style=wxWANTS_CHARS)
        self.list = None
        self.contextMenu = None
        self.name = name
        self.mainframe = mainframe
        tID = NewId()
        self.list = widgets.GUITree.GUITree(self, tID, self.name,
                                    imcom, eventsQueueHash)
        w, h = self.parent.GetClientSizeTuple()
        self.list.SetDimensions(0,0,w,h)
        EVT_SIZE(self, self.OnSize)
        EVT_LEFT_DCLICK(self.list, self.OnLeftDClick)
        EVT_RIGHT_DOWN(self.list, self.onRightClick)
        EVT_MENU(self, IM_RECEIVEEVENT, self.OnMenuGetNextPending)
        EVT_MENU(self, IM_SENDMESSAGE, self.OnMenuSendMessageBox)
        EVT_MENU(self, IM_GETINFO, self.OnMenuGetInfo)
        EVT_MENU(self, IM_REMOVEUSER, self.OnMenuRemoveUser)
        EVT_MENU(self, IM_ADDUSER, self.OnMenuAddUser)
        EVT_MENU(self, IM_SETNICK, self.OnMenuSetNick)
        theid = NewId()
        EVT_MENU(self, theid, self.OnEnter)
        t = wxACCEL_NORMAL, WXK_RETURN, theid
        self.SetAcceleratorTable(wxAcceleratorTable([t]))
        EVT_CLOSE(self, self.OnCloseWindow)

    def createList(self):
        # add users to the tree from the roster.
        for item in imcom.jidhash.keys():
            if(self.findItemByJid(item) == None):
                self.list.addUser(item, dosort=false)
        self.list.doSort()
        return

    def finalize(self):
        if(self.contextMenu != None):
            self.contextMenu.Destroy()
            self.contextMenu = None

    def OnCloseWindow(self, event):
        self.finalize()
        event.Skip()

    def OnSize(self, event):
        w, h = self.parent.GetClientSizeTuple()
        self.list.SetDimensions(0,0,w,h)

    def OnLeftDClick(self, event):
        pt = event.GetPosition();
        jid = self.list.getJidByPoint(pt)
        if(jid == None):
            if(not utils.isEventQueueEmpty()):
                event = utils.getNextEvent() # really returns the top key with something in it..
                self.getNextPendingEvent(event)
            return
        # if we have events pending for this user, display them
        if(eventsQueueHash.has_key(jid) and
           len(eventsQueueHash[jid]) != 0):
            self.getNextPendingEvent(jid)
            return

        # otherwise open up a sendmessage box.
        self.sendMessageBox(jid)

    def OnEnter(self, event):
        jid = self.list.getJidByItem(self.list.GetSelection())
        if(jid == None):
            if(not utils.isEventQueueEmpty()):
                event = utils.getNextEvent() # really returns the top key with something in it..
                self.getNextPendingEvent(event)
            return
        # if we have events pending for this user, display them
        if(eventsQueueHash.has_key(jid) and
           len(eventsQueueHash[jid]) != 0):
            self.getNextPendingEvent(jid)
            return

        # otherwise open up a sendmessage box.
        self.sendMessageBox(jid)


    # This function pops up the Context Menu.
    def onRightClick(self, event):
        jid = self.list.getJidByPoint(event.GetPosition())
        # stop the damn tooltips.
        self.list.timer.Stop()
        self.list.timer2.Stop()
        if(self.list.ttt != None):
            self.list.ttt.Destroy()
        self.list.ttt = None

        # first select the item we right-clicked...
        self.list.selectItemByPoint(event.GetPosition())
        item = self.list.GetSelection()
        if(item == self.list.root and self.name == "Others"):
            self.mainframe.hidepane(self)
            return
        if(jid == None):
            self.PopupMenu(utils.mainmenu,event.GetPosition())
            return

        # create the menu.
        if(self.contextMenu != None):
            self.contextMenu.Destroy()
            self.contextMenu = None
        self.contextMenu = wxMenu("", 0)
        if(eventsQueueHash.has_key(jid) and
           len(eventsQueueHash[jid]) > 0):
            self.contextMenu.Append(IM_RECEIVEEVENT,"Receive Event")
        self.contextMenu.Append(IM_SENDMESSAGE, "Send Message")
        self.contextMenu.Append(IM_GETINFO, "Get Info")
        if(self.name == "Others"):
            self.contextMenu.Append(IM_ADDUSER, "Add User")
        else:
            self.contextMenu.Append(IM_SETNICK, "Set Nickname")
            self.contextMenu.Append(IM_REMOVEUSER, "Remove User")

        # then display the menu
        self.PopupMenu(self.contextMenu,
                       event.GetPosition())

    def OnMenuGetNextPending(self, event):
        item = self.list.GetSelection()
        if(item != None):
            jid = self.list.getJidByItem(item)
            self.getNextPendingEvent(jid)

    def OnMenuSendMessageBox(self, event):
        item = self.list.GetSelection()
        if(item != None):
            jid = self.list.getJidByItem(item)
            if(jid != None):
                self.sendMessageBox(jid)

    def OnMenuGetInfo(self, event):
        item = self.list.GetSelection()
        if(item != None):
            jid = self.list.getJidByItem(item)
            if(jid != None):
                imcom.sendGetInfo(jid)

    def OnMenuRemoveUser(self, event):
        item = self.list.GetSelection()
        if(item != None):
            jid = self.list.getJidByItem(item)
            if(jid != None):
                d = wxMessageDialog(self, "Really remove " + utils.getNick(jid) +
                                    " from your roster?", "Confirm user remove", style=wxYES_NO|wxNO_DEFAULT)
                i = d.ShowModal()
                if i == wxID_YES:
                    self.removeUser(jid)
                    imcom.sendUnsubscribe(jid)

    def OnMenuAddUser(self, event):
        item = self.list.GetSelection()
        if(item != None):
            jid = self.list.getJidByItem(item)
            if(jid != None):
                a = widgets.AddUserFrame.AddUserFrame(self, -1, "", jid, imcom)
                a.Show(true)

    def OnMenuSetNick(self, event):
        item = self.list.GetSelection()
        if(item != None):
            jid = self.list.getJidByItem(item)
            if(jid != None):
                dlg = wxTextEntryDialog(self,
                                        'Enter their new display name',
                                        'Change Nick', '')
                if dlg.ShowModal() == wxID_OK:
                    imcom.setNick(jid, dlg.GetValue())
                dlg.Destroy()

    def getNextPendingEvent(self, jid):
        # take care of the events pending first.
        userEvent = eventsQueueHash[jid].pop(0)
        self.list.setColorForJid(jid)
        if(userEvent[0] == GUIbackend.IM_MessageReceive):
            widgets.EventFrame.EventFrame(self, NewId(), jid,
                                          userEvent)#.Show(true)
        elif(userEvent[0] == GUIbackend.IM_Subscribe):
            widgets.AuthFrame.AuthFrame(self, -1, jid, userEvent).Show(true)


    def sendMessageBox(self, jid):
        t = widgets.MessageFrame.MessageFrame(self, NewId(), jid, imcom)
        #t.Show(true)
        t.textctrl.SetFocus()

    def setStatus(self, stat):
        if(self.list):
            self.list.setStatus(stat)

    def setColorForJid(self, jid):
        if(self.list):
            self.list.setColorForJid(jid)

    def setColorForRoot(self):
        if(self.list):
            self.list.setColorForRoot()

    def removeUser(self, jid):
        if(self.list):
            self.list.removeUser(jid)

    def addUser(self, jid):
        if(self.list):
            self.list.addUser(jid)

    def updateUser(self, jid, nick):
        if(self.list):
            self.list.updateUser(jid, nick)

    def hideoffline(self):
        if(self.list):
            self.list.hideoffline()

    def showoffline(self):
        if(self.list):
            self.list.showoffline()

    def findItemByJid(self, jid):
        if(self.list):
            return self.list.findItemByJid(jid)
        return None

    def hasUser(self, jid):
        if(self.list):
            return self.list.hasUser(jid)
        return 0

    def IsEmpty(self):
        if(self.list):
            return self.list.IsEmpty()
        return 1




class GUIFrame(wxFrame):
    def __init__(self, parent, ID, title, prefs, app):
        global imcom, eventsQueueHash
        wxFrame.__init__(self, parent, ID, title,
                         wxDefaultPosition, wxSize(200, 150))
        # initialize all the backend first.
        self.gb = GUIbackend.GUIBackend(self)
        utils.setBackend(self.gb)
        self.app = app
        self.prefs = prefs
        imcom = self.gb.imcom
        utils.setImcom(imcom)
        self.started = 0


        # now initialize the gui.
        self.splitter = wxSplitterWindow(self, -1,wxPoint(0,0),
                                         wxSize(200,150))
        self.splitter.SetSplitMode(wxSPLIT_HORIZONTAL)
        self.box = wxBoxSizer(wxVERTICAL)
        self.gui = GUI(self.splitter,"MyRoster",self)
        self.others = GUI(self.splitter,"Others",self)
        self.splitter.SetMinimumPaneSize(20)
        self.splitter.SplitHorizontally(self.gui, self.others)
        self.splitter.Unsplit(self.others)
        self.others.Show(false)

        self.box.Add(self.splitter, 1, wxEXPAND)
        self.box.Add(wxButton(self, wxID_OK, " IMCom "),
                0, wxALL | wxEXPAND, 1)
        self.SetAutoLayout(true)
        self.SetSizer(self.box)
        self.box.Fit(self)
        self.SetSize(wxSize(128,256))
        self.Show(true)
        EVT_BUTTON(self, wxID_OK, self.OnClick)

        self.mainmenu = wxMenu("",0)
        self.mainmenu.Append(0, "Online")
        self.mainmenu.Append(1, "Chat")
        self.mainmenu.Append(2, "Away")
        self.mainmenu.Append(3, "XA")
        self.mainmenu.Append(8, "Offline")
        self.mainmenu.AppendSeparator()
        self.mainmenu.Append(7, "Toggle Offline User Display")
        self.mainmenu.AppendSeparator()
        self.mainmenu.Append(5, "Add User")
        self.mainmenu.AppendSeparator()
        self.mainmenu.Append(6, "Preferences")
        self.mainmenu.AppendSeparator()
        self.mainmenu.Append(4, "Quit")
        utils.mainmenu = self.mainmenu
        EVT_MENU(self, 0, self.SetOnline)
        EVT_MENU(self, 1, self.SetChat)
        EVT_MENU(self, 2, self.SetAway)
        EVT_MENU(self, 3, self.SetXA)
        EVT_MENU(self, 8, self.SetOffline)
        EVT_MENU(self, 7, self.ToggleOfflineUserDisplay)
        EVT_MENU(self, 5, self.AddUser)
        EVT_MENU(self, 6, self.Preferences)
        EVT_MENU(self, 4, self.Quit)
        EVT_CLOSE(self, self.OnClose)

    def refit(self):
        self.box.Layout()

    def hidepane(self, pane):
        pane.Show(false)
        self.splitter.Unsplit(pane)

    def ToggleOfflineUserDisplay(self, event):
        if(utils.offlinedisplay):
            utils.offlinedisplay = 0
            self.gui.hideoffline()
        else:
            utils.offlinedisplay = 1
            self.gui.showoffline()

    def login(self, name):
        global eventsQueueHash, imcom
        p = self.prefs.getProfile(name)
        self.profile = name
        utils.setProfile(p)
        # unpickle here
        try:
            f = open(os.environ['HOME']+"/.imcom/events."+self.profile,"r")
            eventsQueueHash = pickle.load(f)
            utils.setEventsQueueHash(eventsQueueHash)
            f.close()
            print "loaded events"
            print eventsQueueHash
        except (IOError, OSError,LookupError):
            eventsQueueHash = {}
            utils.setEventsQueueHash(eventsQueueHash)
            print "couldn't load events"
        self.gb.sendLogin(p.server, int(p.port), p.user,
                          p.password, p.resource, p.switches['ssl'])
        imcom = self.gb.imcom
        utils.imcom = self.gb.imcom
        imcom.setDebug(0)

    def logoff(self):
        print "pickling events"
        print eventsQueueHash
        f = open(os.environ['HOME']+"/.imcom/events."+self.profile,"w")
        pickle.dump(eventsQueueHash,f,1)
        f.flush()
        f.close()
        imcom.disconnect(0)
        self.gui.setStatus(5)


    def IMComEventHandler(self, ie):
        print "Received an ", ie.type, " containing data: ", ie.data
        if(ie.type == GUIbackend.IM_GrabRoster):
            # create the tree.
            self.gui.createList()
            self.started = 1
            utils.status = 1
            if(utils.isEventQueueEmpty()):
                self.gui.setStatus(1)
            else:
                self.gui.setStatus(0)
            return
        if(ie.type == GUIbackend.IM_PresenceUpdate):
            data = ie.data
            jid = data['who']
            if(utils.offlinedisplay):
                self.gui.setColorForJid(data['who'])
            elif(utils.imcom.preshash.has_key(jid) and
                 utils.imcom.preshash[jid][0]):
                if(self.gui.findItemByJid(jid) == None):
                    # add the user to the list
                    self.gui.addUser(jid)
                # update the color
                self.gui.setColorForJid(jid)
            elif(utils.imcom.preshash.has_key(jid) and
                 not utils.imcom.preshash[jid][0]):
                # remove the user from the list
                self.gui.removeUser(jid)

            # they're not in our list. This is a problem.
            return
        if(ie.type == GUIbackend.IM_VCard):
            # create a Info view
            data = ie.data
            self.ShowUserInfo(data)
            return
        if(ie.type == GUIbackend.IM_MessageReceive):
            data = ie.data

            # append to the EventQueueHash
            ddate = None
            ttime = None
            if(data['delay'] != None):
                delay = data['delay']
                mytup = (int(delay[:4]),int(delay[4:6]),int(delay[6:8]),
                         int(delay[9:11]),int(delay[12:14]),
                         int(delay[15:17]),0,0,0)
                thet = time.localtime( time.mktime(mytup) - time.timezone)

                ttime = time.strftime('%H:%M:%S',thet)
                ddate = time.strftime('%m/%d/%Y',thet)
            else:
                ttime = utils.getTime()
                ddate = utils.getDate()
            if(eventsQueueHash.has_key(data['ffrom'])):
                #they already have events pending, append this one
                eventsQueueHash[data['ffrom']].append( (ie.type,
                                                    data['body'],
                                                    data['thread'],
                                                    ddate,
                                                    ttime))
            else:
                # no events pending from this person, start it.
                eventsQueueHash[data['ffrom']] = [(ie.type,
                                                   data['body'],
                                                   data['thread'],
                                                   ddate,
                                                   ttime)]
            utils.addMessageHistory(data['ffrom'], data['ffrom'], ddate,
                                    ttime, data['body'])
            # print eventsQueueHash
            jid = data['ffrom']
            self.gui.setColorForRoot()
            self.others.setColorForRoot()
            if(imcom.jidhash.has_key(jid)):
                # Change the color of the User so we realize something changed.
                if(self.gui.findItemByJid(jid) != None):
                    self.gui.setColorForJid(jid)
                elif(self.others.findItemByJid(jid) != None):
                    self.others.setColorForJid(jid)
            else:
                if(0 == self.others.hasUser(data['ffrom']) and
                   self.started == 1):
                    self.others.addUser(data['ffrom'])
                if(not self.splitter.IsSplit() and self.started == 1):
                    self.others.Show(true)
                    self.splitter.SplitHorizontally(self.gui, self.others)
                    #self.refit()
                self.others.setColorForJid(data['ffrom'])
            utils.beep()
            jid = data['ffrom']
            utils.logMessage(jid, jid, ddate, ttime, data['body'])
            return
        if(ie.type == GUIbackend.IM_Unsubscribed):
            # jid = ie.data['ffrom']
            # self.gui.removeUser(jid)
            return
        if(ie.type == GUIbackend.IM_Subscribed):
            jid = ie.data['ffrom']
            if(self.others.hasUser(jid)):
                self.others.removeUser(jid)
                if(self.others.IsEmpty()):
                    self.splitter.Unsplit(self.others)
            if(not self.gui.hasUser(jid)):
                self.gui.addUser(jid)
            return
        if(ie.type == GUIbackend.IM_RosterUpdate):
            if(ie.data['success']):
                if(self.gui.findItemByJid(ie.data['jid']) != None):
                    self.gui.updateUser(ie.data['jid'], ie.data['name'])
                elif(self.others.findItemByJid(ie.data['jid']) != None):
                    self.others.updateUser(ie.data['jid'], ie.data['name'])
            return
        if(ie.type == GUIbackend.IM_RosterUpdateCheck):
            #if(ie.data['successful']):
            #    self.gui.updateUser(ie.data['jid'], imcom.jidhash[jid])
            return
        if(ie.type == GUIbackend.IM_NoVCard):
            ffrom = ie.data['ffrom']
            nick = utils.getNick(ffrom)
            win = wxMessageDialog(self,
                                  "There is no vCard available for " +ffrom,
                                  "No vCard available",
                                  wxOK|wxICON_ERROR|wxDIALOG_MODELESS)
            win.ShowModal() #(true)
            win.Destroy()
        if(ie.type == GUIbackend.IM_Subscribe):
            #Someone wants to subscribe to us.
            jid = ie.data['ffrom']
            ttime = utils.getTime()
            ddate = utils.getDate()
            if(eventsQueueHash.has_key(jid)):
                eventsQueueHash[jid].append((ie.type,
                                             ddate,
                                             ttime))
            else:
                eventsQueueHash[jid] = [(ie.type,ddate,ttime)]
            if(imcom.jidhash.has_key(jid)):
                self.gui.setColorForJid(jid)
            else:
                if(0 == self.others.hasUser(jid) and self.started == 1):
                    self.others.addUser(jid)
                if(not self.splitter.IsSplit() and self.started == 1):
                    self.others.Show(true)
                    self.splitter.SplitHorizontally(self.gui, self.others)
                self.others.setColorForJid(jid)
            utils.beep()
        if(ie.type == GUIbackend.IM_Unsubscribe):
            #someone wants to unsubscribe to our presense.
            jid = ie.data['ffrom']
            imcom.sendUnsubscribed(jid)
        if(ie.type == GUIbackend.IM_Disconnected):
            if(utils.status != 5):
                utils.status = 5
                self.logoff()
            self.login(self.profile)



    def ShowUserInfo(self, data):
        win =widgets.UserInfoFrame.UserInfoFrame(self, -1, data['ffrom'], data,
                                                 imcom)
        win.Show(true)


    def OnClick(self, event):
        # popup a menu and do stuff..
        self.PopupMenu(self.mainmenu,
                       event.GetEventObject().GetPosition())

    def GetReason(self):
        dlg = wxTextEntryDialog(self,
                                'Enter a reason:',
                                'Reason', "I'm too lazy..")
        if dlg.ShowModal() == wxID_OK:
            return dlg.GetValue()
        return None

    def Preferences(self, event):
        pp = widgets.PreferencesFrame.PreferencesFrame(None, -1, self.prefs,
                                                       imcom, self.app)

    def SetOnline(self, event):
        if(utils.status == 5):
            self.login(self.profile)
            return
        utils.status = 1
        self.gui.setStatus(1)
        imcom.sendOnline()

    def SetChat(self, event):
        if(utils.status == 5):
            self.login(self.profile)
            return
        utils.status = 1
        self.gui.setStatus(1)
        imcom.sendChat()

    def SetAway(self, event):
        if(utils.status == 5):
            self.login(self.profile)
        utils.status = 2
        self.gui.setStatus(2)
        reason = self.GetReason()
        if reason:
            utils.reason = reason
            imcom.sendAway(reason)

    def SetXA(self, event):
        if(utils.status == 5):
            self.login(self.profile)
        utils.status = 3
        self.gui.setStatus(3)
        reason = self.GetReason()
        if reason:
            utils.reason = reason
            imcom.sendXA(reason)

    def SetOffline(self, event):
        if(utils.status != 5):
            utils.status = 5
            self.logoff()

    def AddUser(self, event):
        a = widgets.AddUserFrame.AddUserFrame(self, NewId(), "", "", imcom)
        a.Show(true)

    def OnClose(self, event):
        self.mainmenu.Destroy()
        self.gui.finalize()
        self.others.finalize()
        event.Skip()

    def Quit(self, event):
        self.logoff()
        #self.gui.Destroy()
        #self.others.Destroy()
        self.Close(true)




class GUIApp(wxApp):
    def OnInit(self):
        self.prefs = Preferences.Preferences()
        if(len(sys.argv) > 1):
            p = self.prefs.getProfile(sys.argv[1])
            if(p == None):
                p = self.prefs.getDefaultProfile()
        else:
            p = self.prefs.getDefaultProfile()
        if(p == None):
            # we have no preferences file, create it.
            pf = widgets.PreferencesFrame.PreferencesFrame(None, -1,
                                                           self.prefs,
                                                           utils.imcom, self)
            pf.Show(true)
            self.SetTopWindow(pf)
            self.frame = None
            return true
        else:
            self.frame = GUIFrame(None, -1, "Dummy", self.prefs, self)
            self.SetTopWindow(self.frame)
            self.frame.login(p.name)
            return true

    def applyProfile(self, profilename):
        if(self.frame != None):
            self.frame.Quit(None)
            self.frame.Destroy()
        print "in apply profile, creating new window"
        time.sleep(1)
        self.prefs = Preferences.Preferences()
        self.frame = GUIFrame(None, -1, "Dummy", self.prefs, self)
        print "Created frame, showing"
        self.SetTopWindow(self.frame)
        print "Showed frame, logging in"
        self.frame.login(profilename)
        print "done"
        return true


if __name__ == "__main__":
    app = GUIApp(0)
    app.MainLoop()
