import os
import sys
import traceback
import binascii
import random
import struct
from threading import *

INITIALSTATE = 0
ACCEPTLINK   = 1
NEGOTIATION  = 2
CONNECTION   = 3
CONNECTED    = 4

class JIDLink:
  def __init__(self, to, resource, key, action, imcom):
    self.key = key
    self.to = to
    self.resource = resource
    self.imcom = imcom
    self.connectionType = None # one of "dtcp-active", "dtcp-passive", "ibb"?
    self.connectionObject = None #probably a DTCP object
    self.actionObject = action # must inherit from thread, must have setConnectionObject(self, theObj)

  def connectionComplete(self, success):
    if success:
      print "woot! JIDLink connected!"
      self.imcom.jidlinkEstablished(self.to + "/" + self.resource, self)
    else:
      pass # BUG BUG BUG, do something.

    if self.actionObject != None:
      print "running the action object."
      self.actionObject.setConnectionObject(self.connectionObject)
      self.actionObject.start()
    else:
      print "no action object, closing"
      self.connectionObject.closeSocket()

  def connectionClosed(self, success):
    # BUG BUG BUG  clean up shit here
    if self.actionObject != None:
      self.actionObject.connectionClosed(success)
    self.imcom.removeJIDLink(self)

  def setConnectionObject(self, obj):
    print "setting connection object."
    self.connectionObject = obj
    obj.connectedCallback = self.connectionComplete
    obj.finishedCallback = self.connectionClosed


class JIDLinkTestModeAction(Thread):
  def __init__(self):
    Thread.__init__(self)
    self.connectionObject = None
    self.running = 1

  def connectionClosed(self, success):
    self.running = 0

  def setConnectionObject(self, obj):
    self.connectionObject = obj


  def run(self):
    mydata = ""
    #for i in range(2048/8):
    while len(mydata) != 2048:
      mydata = mydata + str(int(random.random() * 10) % 10)
    print "I have my data"
    myhash = struct.pack("i", binascii.crc32(mydata))
    print "I have my hash"
    if self.connectionObject.isInitiator == 1:
      print "sending my data"
      self.connectionObject.sendData(mydata)
      print "sending my hash"
      self.connectionObject.sendData(myhash)
      print "recving their data"
      data = self.connectionObject.recvData(2048)
      print "Recving their hash"
      hash = self.connectionObject.recvData(4)
      if struct.unpack("i", hash)[0] == binascii.crc32(data):
        print "Good to go!"
      else:
        print "!!!! Their hash doesn't match!"
    else:
      print "recving their data"
      data = self.connectionObject.recvData(2048)
      print "Recving their hash"
      hash = self.connectionObject.recvData(4)
      if struct.unpack("i", hash)[0] == binascii.crc32(data):
        print "Good to go!"
      else:
        print "!!!! Their hash doesn't match!"
      print "sending my data"
      self.connectionObject.sendData(mydata)
      print "sending my hash"
      self.connectionObject.sendData(myhash)

    print "closing the socket, all done.\n"
    self.connectionObject.closeSocket()
