#import readline
import string
from wxPython.wx import *

def tabCompleter(text, state):
    print
    params = string.split(readline.get_line_buffer())
    print
    print params
    print
    if(len(params) == 1 and readline.get_line_buffer()[-1] != ' '):
        # We're tab completing a command
        print "Command tab completion"
        return None
    if((len(params) == 1 and readline.get_line_buffer()[-1] == ' ') or
       (len(params) == 2 and readline.get_line_buffer()[-1] != ' ')):
        # We're probably completing a nick
        print "Nick tab completion"
        return None
    if((len(params) == 3 and readline.get_line_buffer()[-1] != ' ') or
       (len(params) == 2 and readline.get_line_buffer()[-1] == ' ')):
        # Command specific tab completion
        print "Command specific tab completion"
        return None
    print "text was < ", text, " >"
    print "state was < ", state, " >"
    print "readline buffer was < ", readline.get_line_buffer(), " >"
    print

class UserInfoPanel(wxPanel):
    def __init__(self, parent, ID, jid, nick, ddate, ttime):
        wxPanel.__init__(self, parent, ID)
        # Create the StaticBox which will house all the information
        topInfoComp = wxStaticBox(self, -1, "From:")
        infobox = wxStaticBoxSizer(topInfoComp, wxVERTICAL)
        # Now create the first box that will be put in the StaticBox
        topInfoBox = wxBoxSizer(wxVERTICAL)
        # Add infobox first so we get the StaticBox around our stuff
        topInfoBox.Add(infobox, 1, wxEXPAND)
        # create a horizontal box for position purposes
        infobox2 = wxBoxSizer(wxHORIZONTAL)
        # add the JID information to that box.
        infobox2.Add(wxStaticText(self, -1, "JID: "),
                     0, wxEXPAND|wxALL, 4)
        infobox2.Add(wxStaticText(self, -1, jid,
                                  style=wxSUNKEN_BORDER|wxALIGN_CENTRE),
                     2, wxEXPAND|wxALL, 0)

        # if we have a nick, add it to the right of the JID
        if(nick != None):
            infobox2.Add(wxStaticText(self, -1, "Nick Name: "),
                         0, wxEXPAND | wxALL, 4)
            infobox2.Add(wxStaticText(self, -1, nick,
                                      style=wxSUNKEN_BORDER|wxALIGN_CENTRE),
                         1, wxEXPAND | wxALL, 0)

        # add the first horizontal layer of information to the Vertical Box
        infobox.Add(infobox2, 1, wxEXPAND|wxALL, 4)

        # create a new horizontal layer
        infobox2 = wxBoxSizer(wxHORIZONTAL)

        # add the date and time to this horizontal layer
        infobox2.Add(wxStaticText(self, -1, "Date: "),
                     0, wxEXPAND|wxALL, 4)
        infobox2.Add(wxStaticText(self, -1, ddate,
                                  style=wxSUNKEN_BORDER|wxALIGN_CENTRE),
                     1, wxEXPAND|wxALL, 0)
        infobox2.Add(0,0,1,wxEXPAND)
        infobox2.Add(wxStaticText(self, -1, "Time: "),
                     0, wxEXPAND|wxALL, 4)
        infobox2.Add(wxStaticText(self, -1, ttime,
                                  style=wxSUNKEN_BORDER|wxALIGN_CENTRE),
                     1, wxEXPAND|wxALL, 0)

        # add the new horizontal layer to the vertical layer
        infobox.Add(infobox2, 1, wxEXPAND|wxALL,4)

        # Tell the from information panel that it will be layed out
        # automatically by the topInfoBox (which is the StaticBoxSizer)
        self.SetAutoLayout(true)
        self.SetSizer(topInfoBox)
        topInfoBox.Fit(self)

class EventFrame(wxFrame):
    def __init__(self, parent, ID, jid, userEvent):
        wxFrame.__init__(self, parent, ID, "Read a Message",
                         wxDefaultPosition, wxSize(350, 350),
                         style=wxDEFAULT_FRAME_STYLE | wxWANTS_CHARS)

        # Setup Some basic variables
        self.jid = jid
        self.parent = parent
        nick = getNickOrNone(jid)

        fromInfoPanel = UserInfoPanel(self, ID, jid, nick,
                                      userEvent[3],
                                      userEvent[4])

        # Create a new box for the messagePanel
        messagePanel = wxPanel(self, -1)
        messageBox = wxBoxSizer(wxVERTICAL)
        textID = NewId()
        # Add the message into the new box
        messageBox.Add(wxTextCtrl(messagePanel, textID, userEvent[1],
                                  style=wxTE_MULTILINE|wxTE_READONLY),
                       1, wxEXPAND | wxALL, 10)
        messagePanel.SetAutoLayout(true)
        messagePanel.SetSizer(messageBox)
        messageBox.Fit(messagePanel)



        # Now create the response panel which will house all the action buttons
        responsePanel = wxPanel(self, -1, style=0)
        responseComp = wxStaticBox(responsePanel, NewId(), "Response Action:")
        responseBox = wxStaticBoxSizer(responseComp, wxHORIZONTAL)

        # Create the buttons
        self.closeButton = wxButton(responsePanel, wxID_CANCEL, " Close ")
        self.replyButton = wxButton(responsePanel, wxID_OK, " Reply ")

        # Add the buttons with a spacer in the middle
        responseBox.Add(self.closeButton, 0, wxALL|wxALIGN_LEFT, 10)
        responseBox.Add(0,0,1,wxEXPAND)
        responseBox.Add(self.replyButton,0, wxALL|wxALIGN_RIGHT, 10)
        responsePanel.SetAutoLayout(true)
        responsePanel.SetSizer(responseBox)
        responseBox.Fit(responsePanel)

        # Create the topBox for holding all 3 panels
        # add the panels in order
        # then set the autolayout.
        topBox = wxBoxSizer(wxVERTICAL)
        topBox.Add(fromInfoPanel,0,wxEXPAND)
        topBox.Add(messagePanel,1,wxEXPAND)
        topBox.Add(responsePanel, 0, wxEXPAND)
        self.SetAutoLayout(true)
        self.SetSizer(topBox)
        topBox.Fit(self)

        EVT_BUTTON(self, wxID_OK, self.OnOK)
        EVT_BUTTON(self, wxID_CANCEL, self.OnCancel)
        EVT_MENU(self, wxID_OK, self.OnOK)
        EVT_MENU(self, wxID_CANCEL, self.OnCancel)
        t = wxACCEL_NORMAL, WXK_ESCAPE, wxID_CANCEL
        responsePanel.SetAcceleratorTable(wxAcceleratorTable([t]))


    def Show(self,b):
        wxFrame.Show(self,b)
        self.SetSize(wxSize(460,325))
        if(b):
            self.replyButton.SetFocus()

    def OnOK(self, event):
        #we're replying to the message...
        self.Show(false)
        self.Destroy()
        print "reply"
        #self.parent.sendMessageBox(self.jid)

    def OnCancel(self, event):
        self.Show(false)
        self.Destroy()
        print "cancel"

def testReadline():
    readline.parse_and_bind("tab: complete")
    readline.parse_and_bind("set bell-style none")
    readline.set_completer(tabCompleter)
    running = 1
    while(running):
        line = raw_input("prompt> ")

def getNickOrNone(jid):
    return "no one"

class GUIApp(wxApp):
    def OnInit(self):
        self.frame = EventFrame(None, -1, "no-one@none.org", (None,"This is the message",None,"05-06-2001","06:30:00"))
        self.SetTopWindow(self.frame)
        self.frame.Show(true)
        #self.frame.login()
        #a = wxToolTip("Dummy")
        #a.Enable(true)
        #a.SetDelay(200)
        #a.Destroy()
        #a = None
        return true


def testEventFrame():
    app = GUIApp(0)
    app.MainLoop()

if __name__ == "__main__":
    testEventFrame()

